/*
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the Shared Code
 * License (SCL) as published by www.IntellectualHeaven.com;
 * either version 1.0, or (at your option) any later version.
 *
 * You should have received a copy of the SCL 1.0 license,
 * look for file license.txt, along with this software; if not,
 * then please write to xx_pankaj_xx@intellectualheaven.com
 * for an electronic copy of the same.
 */

/* ++
History (in reverse order)

xx_pankaj_xx@intellectualheaven.com   2003-08-18
First version created and checked in CVS
-- */

// RecServerNT.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "all_defines.h"
#include "GlobalData.h"
#include "ReC_Service.h"

extern DWORD WINAPI main_thread(void *p_v_param);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	SERVICE_TABLE_ENTRY dispatch_table[] =
	{
		{	SZ_SERVICE_NAME, (LPSERVICE_MAIN_FUNCTION)my_service_main	},
		{	NULL,	NULL	}
	};


	if (stricmp("-install", lpCmdLine) == 0)
	{
		cmd_install_service();
	}
	else if (stricmp("-remove", lpCmdLine) == 0)
	{
		cmd_remove_service();
	}
	else
		goto dispatch_service;

	return 0;

dispatch_service:
	if (!StartServiceCtrlDispatcher(dispatch_table))
	{
		
	}


	return 0;
}




void service_start()
{
	report_status_to_sc_manager	
			(	SERVICE_RUNNING,
				NO_ERROR,
				0
			);


	g_main_thread = CreateThread(	NULL,
									0,
									main_thread,
									NULL,
									NULL,
									NULL);

	if (g_main_thread == NULL)
	{
		report_status_to_sc_manager	
			(	SERVICE_STOPPED,
				NO_ERROR,
				0
			);
		return;
	}

	WaitForSingleObject(	g_main_thread,
							INFINITE);
}


void service_stop()
{
	b_exit = true;
}


void service_pause()
{
	SuspendThread(g_main_thread);
}


void service_continue()
{
	ResumeThread(g_main_thread);
}

void WINAPI my_service_ctrl(unsigned long l_ctrl_code)
{
	switch (l_ctrl_code)
	{
	case SERVICE_CONTROL_STOP:
		report_status_to_sc_manager(	SERVICE_STOP_PENDING,
										NO_ERROR,
										0);

		service_stop();
		report_status_to_sc_manager(	SERVICE_STOPPED,
										NO_ERROR,
										0);
		return;
	case SERVICE_CONTROL_PAUSE:
		report_status_to_sc_manager(	SERVICE_PAUSE_PENDING,
										NO_ERROR,
										0);

		service_pause();
		report_status_to_sc_manager(	SERVICE_PAUSED,
										NO_ERROR,
										0);
		return;
	case SERVICE_CONTROL_CONTINUE:
		report_status_to_sc_manager(	SERVICE_CONTINUE_PENDING,
										NO_ERROR,
										0);

		service_continue();
		report_status_to_sc_manager(	SERVICE_RUNNING,
										NO_ERROR,
										0);
		return;
	case SERVICE_CONTROL_INTERROGATE:
		break;
	default:
		break;
	}
	
	report_status_to_sc_manager(	g_service_status.dwCurrentState,
									NO_ERROR,
									0);
}


void WINAPI my_service_main(long argC, char **argV)
{
	g_service_status_handle = RegisterServiceCtrlHandler
								(
									SZ_SERVICE_NAME,
									my_service_ctrl
								);

	if (!g_service_status_handle)
	{
		return;
	}

	g_service_status.dwServiceType		= SERVICE_WIN32_OWN_PROCESS;
	g_service_status.dwWin32ExitCode	= 0;

	if (!report_status_to_sc_manager
			(
				SERVICE_START_PENDING,
				NO_ERROR,
				3000
			))
	{
		goto clean_up;
	}
	service_start();

clean_up:
	if (g_service_status_handle)
	{
		report_status_to_sc_manager
			(
				SERVICE_STOPPED,
				g_l_err,
				0
			);
	}

	return;
}



bool report_status_to_sc_manager
(
	long l_cur_state,
	long l_exit_code,
	long l_wait
)
{
	static long l_check_point = 1;
	bool b_result = true;

	if (l_cur_state == SERVICE_START_PENDING)
	{
		g_service_status.dwControlsAccepted = 0;
	}
	else
	{
		g_service_status.dwControlsAccepted =	SERVICE_ACCEPT_STOP |
												SERVICE_ACCEPT_PAUSE_CONTINUE;
	}

	g_service_status.dwCurrentState		= l_cur_state;
	g_service_status.dwWin32ExitCode	= l_exit_code;
	g_service_status.dwWaitHint			= l_wait;

	if ( l_cur_state == SERVICE_RUNNING  || l_cur_state == SERVICE_STOPPED )
	{
		g_service_status.dwCheckPoint = 0;
	}
	else
	{
		g_service_status.dwCheckPoint = l_check_point++;
	}

	if (! (b_result = SetServiceStatus(	g_service_status_handle,
										&g_service_status
										)))
	{
		;//Error
	}

	return b_result;
}


void cmd_install_service()
{
	SC_HANDLE sch_service;
	SC_HANDLE sch_sc_mgr;

	char sz_path[MAX_PATH];

	if (GetModuleFileName(	NULL,
							sz_path,
							MAX_PATH) == 0)
	{
		;	//Error
	}

	sch_sc_mgr = OpenSCManager(	NULL,	//Local Machine
								NULL,	//Database (default)
								SC_MANAGER_ALL_ACCESS);

	if (sch_sc_mgr)
	{
		sch_service = CreateService(	sch_sc_mgr,
										SZ_SERVICE_NAME,
										SZ_SERVICE_DISP_NAME,
										SERVICE_ALL_ACCESS,
										SERVICE_WIN32_OWN_PROCESS |
										SERVICE_INTERACTIVE_PROCESS,
										SERVICE_DEMAND_START,
										SERVICE_ERROR_NORMAL,
										sz_path,
										NULL,
										NULL,
										SZ_SERVICE_DEPENDENCIES,
										NULL,
										NULL);

		if (sch_service)
		{
			/*
			::MessageBox(	NULL,
							"ReC Service Installed",
							"ReC Service",
							MB_OK);
			*/
		}
		else
		{
			::MessageBox(	NULL,
							"ReC Service Installed",
							"ReC Service",
							MB_OK);
		}

		CloseServiceHandle(sch_sc_mgr);
	}
	else
	{
		::MessageBox(	NULL,
						"ReC Service Installed",
						"ReC Service",
						MB_OK);
	}
}


void cmd_remove_service()
{
	SC_HANDLE sch_service;
	SC_HANDLE sch_sc_mgr;


	sch_sc_mgr = OpenSCManager(	NULL,	//Local Machine
								NULL,	//Database (default)
								SC_MANAGER_ALL_ACCESS);

	if (sch_sc_mgr)
	{
		sch_service = OpenService(	sch_sc_mgr,
									SZ_SERVICE_NAME,
									SERVICE_ALL_ACCESS);

		if (sch_service)
		{
			if (ControlService(	sch_service,
								SERVICE_CONTROL_STOP,
								&g_service_status))
			{
				//printf ("\nTrying to stop service.");
				Sleep(1000);

				while (QueryServiceStatus(	sch_service,
											&g_service_status))
				{
					if (g_service_status.dwCurrentState == SERVICE_STOP_PENDING)
					{
						//printf(".");
						Sleep(1000);
					}
					else
					{
						break;
					}
				}

				if (g_service_status.dwCurrentState == SERVICE_STOPPED)
				{
					//printf ("\nService stopped...");
				}
				else
				{
					//printf ("\nService stop failed...");
				}
			}
			else
			{
				//printf("\nError = %d",GetLastError());
			}

			if (DeleteService(sch_service))
			{
				//printf("\nService successfully deleted.");
			}
			else
			{
				//printf("\nDeleteService failed. Error = %d",GetLastError());
			}
			CloseServiceHandle(sch_service);
		}
		else
		{
			//printf ("\nOpenService Failed. Error = %d", GetLastError());
		}

		CloseServiceHandle(sch_sc_mgr);
	}
	else
	{
		//printf ("\nOpenSCMgr Failed. Error = %d", GetLastError());
	}
}
