/*
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the Shared Code
 * License (SCL) as published by www.IntellectualHeaven.com;
 * either version 1.0, or (at your option) any later version.
 *
 * You should have received a copy of the SCL 1.0 license,
 * look for file license.txt, along with this software; if not,
 * then please write to xx_pankaj_xx@intellectualheaven.com
 * for an electronic copy of the same.
 */

/* ++
History (in reverse order)

xx_pankaj_xx@intellectualheaven.com   2003-08-18
First version created and checked in CVS
-- */

// L_SERVICE.cpp : implementation file
//

#include "stdafx.h"
#include "ReCClient.h"
#include "L_GENERIC_SOCKET.h"
#include "L_SERVICE.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CL_SERVICE dialog
extern SOCKET g_sock_client;
extern bool g_is_connected;
int gn_first = 0;


CL_SERVICE::CL_SERVICE(CWnd* pParent /*=NULL*/)
	: CDialog(CL_SERVICE::IDD, pParent)
{
	//{{AFX_DATA_INIT(CL_SERVICE)
	m_service_name = _T("");
	m_service_status = _T("");
	//}}AFX_DATA_INIT
}


void CL_SERVICE::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CL_SERVICE)
	DDX_Control(pDX, IDC_BTN_SHOW, m_btn_show);
	DDX_Text(pDX, IDC_ED_SERVICE_NAME, m_service_name);
	DDX_Text(pDX, IDC_ED_SERVICE_STATUS, m_service_status);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CL_SERVICE, CDialog)
	//{{AFX_MSG_MAP(CL_SERVICE)
	ON_BN_CLICKED(IDC_BTN_SHOW, OnBtnShow)
	ON_BN_CLICKED(IDC_BTN_START, OnBtnStart)
	ON_BN_CLICKED(IDC_BTN_STOP, OnBtnStop)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CL_SERVICE message handlers

void CL_SERVICE::OnBtnShow() 
{
	if (gn_first == 0)
	{
		UpdateData(TRUE);
		SetTimer(	202,
					10000,
					NULL);
		m_btn_show.SetWindowText("Stop Status");
		gn_first =  1;
	}
	else
	{
		gn_first = 0;
		KillTimer(202);
		m_btn_show.SetWindowText("s&How Status");
		m_service_status = "";
		UpdateData(FALSE);
	}
}

void CL_SERVICE::OnBtnStart() 
{
	CString sz_data;
	sz_data = "StartService|*|*|";
	sz_data = sz_data + m_service_name + "|*|*|";

	if(CL_GENERIC_SOCKET::Send(	g_sock_client,
								(void*)(LPCTSTR)sz_data,
								sz_data.GetLength()) < sz_data.GetLength())
	{
		CReCClientApp::ShowError();
	}
}

void CL_SERVICE::OnBtnStop() 
{
	CString sz_data;
	sz_data = "StopService|*|*|";
	sz_data = sz_data + m_service_name + "|*|*|";

	if(CL_GENERIC_SOCKET::Send(	g_sock_client,
								(void*)(LPCTSTR)sz_data,
								sz_data.GetLength()) < sz_data.GetLength())
	{
		CReCClientApp::ShowError();
	}
}

void CL_SERVICE::OnTimer(UINT nIDEvent) 
{
	if (nIDEvent == 202)
	{
		CString sz_data;
		sz_data = "StatusService|*|*|";
		sz_data = sz_data + m_service_name + "|*|*|";
		if(CL_GENERIC_SOCKET::Send(	g_sock_client,
									(void*)(LPCTSTR)sz_data,
									sz_data.GetLength()) < sz_data.GetLength())
		{
			KillTimer(202);
			CReCClientApp::ShowError();
			EndDialog(0);
			return;
		}

		char sz_proc_data[512];
		int n_bytes_to_come;
		int n_int_size = sizeof(int);
		if(CL_GENERIC_SOCKET::Receive(	g_sock_client,
										(void *)&n_bytes_to_come,
										sizeof(int)) < n_int_size)
		{
			KillTimer(202);
			CReCClientApp::ShowError();
			EndDialog(0);
			return;
		}
		else
		{
			if(CL_GENERIC_SOCKET::Receive(	g_sock_client,
											sz_proc_data,
											n_bytes_to_come) < n_bytes_to_come)
			{
				KillTimer(202);
				CReCClientApp::ShowError();
				EndDialog(0);
				return;
			}
			else
			{
				sz_proc_data[n_bytes_to_come] = '\0';
				m_service_status = sz_proc_data;
				UpdateData(FALSE);
			}
		}
	}
	CDialog::OnTimer(nIDEvent);
}

BOOL CL_SERVICE::OnInitDialog() 
{
	CDialog::OnInitDialog();
	gn_first = 0;	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
