/*
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the Shared Code
 * License (SCL) as published by www.IntellectualHeaven.com;
 * either version 1.0, or (at your option) any later version.
 *
 * You should have received a copy of the SCL 1.0 license,
 * look for file license.txt, along with this software; if not,
 * then please write to xx_pankaj_xx@intellectualheaven.com
 * for an electronic copy of the same.
 */

/* ++
History (in reverse order)

xx_pankaj_xx@intellectualheaven.com   2003-08-18
First version created and checked in CVS
-- */

// ReCClient.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "ReCClient.h"

#include "MainFrm.h"
#include "ReCClientDoc.h"
#include "ReCClientView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CReCClientApp
extern SOCKET g_sock_client;
extern bool g_is_connected;

BEGIN_MESSAGE_MAP(CReCClientApp, CWinApp)
	//{{AFX_MSG_MAP(CReCClientApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReCClientApp construction

CReCClientApp::CReCClientApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CReCClientApp object

CReCClientApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CReCClientApp initialization

BOOL CReCClientApp::InitInstance()
{
	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();

	// Standard initialization

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register document templates

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CReCClientDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CReCClientView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	m_pMainWnd->SetWindowText("Remote Control - A Powerful Remote Administration Tool");
	m_pMainWnd->ShowWindow(SW_MAXIMIZE);
	m_pMainWnd->UpdateWindow();

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnPaint();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	bool b_is_mail;
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
	b_is_mail = false;
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CReCClientApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CReCClientApp message handlers


void CReCClientApp::ShowError()
{
	AfxMessageBox("\nConnection to server lost, Closing dialog...");
	closesocket(g_sock_client);
	g_is_connected = false;
}

void CAboutDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	CFont font;
	font.CreateFont(	18,9,0,0,0,
						FALSE,FALSE,FALSE,
						ANSI_CHARSET,
						OUT_DEFAULT_PRECIS,
						CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY,
						DEFAULT_PITCH | FF_DONTCARE,
						"Arial");

	dc.SetBkMode(TRANSPARENT);
	CFont *pOldFont = dc.SelectObject(&font);
	dc.SetTextColor(RGB(0,0,128));
	dc.TextOut(80,20,"Remote Control");
	font.DeleteObject();

	font.CreateFont(	12,6,0,0,0,
						FALSE,FALSE,FALSE,
						ANSI_CHARSET,
						OUT_DEFAULT_PRECIS,
						CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY,
						DEFAULT_PITCH | FF_DONTCARE,
						"Arial");
	dc.SelectObject(pOldFont);
	pOldFont = dc.SelectObject(&font);
	dc.SetTextColor(RGB(0,0,0));
	dc.TextOut(114,42,"Version 1.0");
	dc.TextOut(82,52,"Updated: August 2nd, 2003");

	font.DeleteObject();

	font.CreateFont(	14,6,0,0,0,
						FALSE,FALSE,FALSE,
						ANSI_CHARSET,
						OUT_DEFAULT_PRECIS,
						CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY,
						DEFAULT_PITCH | FF_DONTCARE,
						"Arial");

	dc.SelectObject(pOldFont);
	pOldFont = dc.SelectObject(&font);
	dc.TextOut(102,65,"Bug Reporting To:");

	if (b_is_mail == true)
		dc.SetTextColor(RGB(0,0,255));
	else
		dc.SetTextColor(RGB(155,0,0));
	dc.TextOut(68,78,"me_pankajgarg@hotmail.com");

	font.DeleteObject();
	font.CreateFont(	12,6,0,0,FW_SEMIBOLD,
						FALSE,FALSE,FALSE,
						ANSI_CHARSET,
						OUT_DEFAULT_PRECIS,
						CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY,
						DEFAULT_PITCH | FF_DONTCARE,
						"Arial");
	dc.SelectObject(pOldFont);
	pOldFont = dc.SelectObject(&font);
	dc.SetTextColor(RGB(0,100,100));
	dc.TextOut(19,100,"ReC ");

	font.DeleteObject();
	font.CreateFont(	12,6,0,0,0,
						FALSE,FALSE,FALSE,
						ANSI_CHARSET,
						OUT_DEFAULT_PRECIS,
						CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY,
						DEFAULT_PITCH | FF_DONTCARE,
						"Arial");
	dc.SelectObject(pOldFont);
	pOldFont = dc.SelectObject(&font);
	dc.SetTextColor(RGB(0,0,0));
	dc.TextOut(44,100,"is a freeware and it is meant only for educational");
	dc.TextOut(19,110,"purpose. Full source code of ReC can be obtained");

	if (b_is_mail == true)
		dc.SetTextColor(RGB(0,0,255));
	else
		dc.SetTextColor(RGB(155,0,0));

	dc.TextOut(19,120,"from Pankaj Garg");
	dc.SetTextColor(RGB(0,0,0));
	dc.TextOut(19,120,"from");
	
/*
	if (m_mouse_on_mail)
		dc.SetTextColor(RGB(0,0,255));
	else
		dc.SetTextColor(RGB(0,100,100));
	dc.TextOut(80,134,"pankaj_k_garg@usa.net");
*/
	dc.SelectObject(pOldFont);
	//CDialog::OnPaint();
	// Do not call CDialog::OnPaint() for painting messages
}

void CAboutDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	TRACE("\nX = %d, Y = %d", point.x, point.y);

	if (	(point.x >= 69 && point.x <= 232 && point.y >= 82 && point.y <= 90)
			|| (point.x >= 40 && point.x <= 107 && point.y >= 120 && point.y <= 130))
	{
		if (b_is_mail == false)
		{
			b_is_mail = true;
			InvalidateRect(CRect(40,80,233,132), FALSE);
		}
		SetCursor(LoadCursor(GetModuleHandle(NULL), MAKEINTRESOURCE(IDC_HAND_MY_2)));
	}
	else
	{
		if (b_is_mail == true)
		{
			b_is_mail = false;
			InvalidateRect(CRect(40,80,233,132), FALSE);
		}
	}

	CDialog::OnMouseMove(nFlags, point);
}

void CAboutDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if (b_is_mail == true)
		ShellExecute(this->GetSafeHwnd(), NULL, "mailto: me_pankajgarg@hotmail.com", NULL, NULL, SW_SHOW | SW_MAXIMIZE);

	CDialog::OnLButtonDown(nFlags, point);
}
