/*
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the Shared Code
 * License (SCL) as published by www.IntellectualHeaven.com;
 * either version 1.0, or (at your option) any later version.
 *
 * You should have received a copy of the SCL 1.0 license,
 * look for file license.txt, along with this software; if not,
 * then please write to xx_pankaj_xx@intellectualheaven.com
 * for an electronic copy of the same.
 */

/* ++
History (in reverse order)

xx_pankaj_xx@intellectualheaven.com   2003-08-18
First version created and checked in CVS
-- */

// ReCClientView.cpp : implementation of the CReCClientView class
//

#include "stdafx.h"
#include "ReCClient.h"

#include "ReCClientDoc.h"
#include "ReCClientView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CReCClientView

IMPLEMENT_DYNCREATE(CReCClientView, CView)

BEGIN_MESSAGE_MAP(CReCClientView, CView)
	//{{AFX_MSG_MAP(CReCClientView)
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_LBUTTONDOWN()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReCClientView construction/destruction

CReCClientView::CReCClientView()
{
	m_bit_map.LoadBitmap(IDB_MY_INFO);

	m_b_email_hi = m_b_web_hi = false;

}

CReCClientView::~CReCClientView()
{
}

BOOL CReCClientView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CReCClientView drawing

void CReCClientView::OnDraw(CDC* pDC)
{
	CReCClientDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
}

/////////////////////////////////////////////////////////////////////////////
// CReCClientView printing

BOOL CReCClientView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CReCClientView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

void CReCClientView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

/////////////////////////////////////////////////////////////////////////////
// CReCClientView diagnostics

#ifdef _DEBUG
void CReCClientView::AssertValid() const
{
	CView::AssertValid();
}

void CReCClientView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CReCClientDoc* CReCClientView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CReCClientDoc)));
	return (CReCClientDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CReCClientView message handlers

void CReCClientView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	TRACE("\nPAINT EMAIL = %d, WEB = %d",m_b_email_hi, m_b_web_hi);	

    RECT rect;
	GetClientRect(&rect);

    CFont Font;
    CFont *pOldFont = NULL;
    int n_vert_margin_from_bottom = 0;
    int n_vert_margin_from_top = 0;

	BITMAP bm;
	m_bit_map.GetBitmap(&bm);

	CDC temp_dc;
	temp_dc.CreateCompatibleDC(NULL);
	CBitmap *p_old_bmp = temp_dc.SelectObject(&m_bit_map);	

	dc.StretchBlt(0,0,rect.right,rect.bottom, &temp_dc, 0, 0,  bm.bmWidth, bm.bmHeight,SRCCOPY);
	temp_dc.SelectObject(p_old_bmp);

    int nFontHeight = (24 * rect.bottom)/663;
    int nFontWidth = (nFontHeight * 8)/16;

    TRACE("nFontHeight = %d\n", nFontHeight);

	Font.CreateFont(	nFontHeight, nFontWidth, 0, 0, FW_NORMAL,
						FALSE,FALSE,FALSE,
						ANSI_CHARSET,
						OUT_DEFAULT_PRECIS,
						CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY,
						DEFAULT_PITCH|FF_SWISS,
						"Courier New");

    pOldFont = dc.SelectObject(&Font);

    CString szText =    "/*******************************************************************\n"
                        "REC (REmote Control) is a free software. You can redistribute\n"
                        "it or use it as long as you want free of cost. REC is distributed\n"
                        "in the hope that it will be useful, but it DOES NOT carry any\n"
                        "warranty, not even the implied warranty of MERCHANTABILITY\n"
                        " or FITNESS FOR A PARTICULAR PURPOSE.\n\n"
                        "You should have received a copy of the license along with\n"
                        "REC, see the file 'license.txt'. If not, please send an email to\n"
                        "the contact address given below, for an electronic copy of\n"
                        "the same.\n\n"
                        "REC is developed by Pankaj Garg.\n"
                        "You can reach him at me_pankajgarg@hotmail.com\n"
                        "*******************************************************************/";



    n_vert_margin_from_top = 5;

    dc.SetBkMode(TRANSPARENT);
    dc.SetTextColor(RGB(0xA0, 0xFF, 0x40));

    // This color looks good with backup image.
    // Backup image bak_my_info.bmp is Really cool
    // but i am not using it
    // because my standard color scheme is different
    // dc.SetTextColor(RGB(138, 228, 244));

    RECT rect_new;

    rect_new.top    = rect.top + 25;
    rect_new.bottom = rect.top + 30;
    rect_new.left   = rect.left + 25;
    rect_new.right  = rect.right - 25;

    dc.DrawText(szText, &rect_new, DT_CALCRECT);

    rect_new.left   = rect.left + 25;
    rect_new.right  = rect.right - 25;

    dc.DrawText(szText, &rect_new, DT_CENTER);

    rect_new.top -= 10;
    rect_new.bottom += 5;
    rect_new.left -= 5;
    rect_new.right += 5;
    dc.Draw3dRect(&rect_new, RGB(64, 128, 0), RGB(128, 255, 0));

    /*
    int n_hor_margin = 20;

    while (*sz_text1)
    {
        dc.TextOut(	rect.left + n_hor_margin, rect.top + n_vert_margin_from_top, sz_text1++, 1);
        n_hor_margin += 16;

        if (n_hor_margin >= rect.right - 20)
        {
            n_hor_margin = 20;
            n_vert_margin_from_top += 30;
        }
    }
    */

    Font.DeleteObject();

    n_vert_margin_from_bottom = 54;

	Font.CreateFont(	22,0,0,0,FW_NORMAL,
						FALSE,FALSE,FALSE,
						ANSI_CHARSET,
						OUT_DEFAULT_PRECIS,
						CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY,
						DEFAULT_PITCH|FF_SWISS,
						"Arial");

	dc.SelectObject(&Font);
	
    dc.SetBkMode(TRANSPARENT);
	dc.SetTextColor(RGB(0x45,0x90, 0));

    dc.TextOut(	(rect.right/2) - 79, rect.bottom - n_vert_margin_from_bottom, "contact information");

    Font.DeleteObject();

    Font.CreateFont(	22,0,0,0,0,
						TRUE,TRUE,FALSE,
						ANSI_CHARSET,
						OUT_DEFAULT_PRECIS,
						CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY,
						DEFAULT_PITCH|FF_SWISS,
						"Arial");

	dc.SelectObject(&Font);

    dc.SetBkMode(TRANSPARENT);    

    if (m_b_email_hi)
    {
        dc.SetTextColor(RGB(255,198,0));
        dc.TextOut(	(rect.right/2) - 120, rect.bottom - n_vert_margin_from_bottom + 27, "me_pankajgarg@hotmail.com");
    }
    else
    {
        dc.SetTextColor(RGB(153,255,102));
		dc.TextOut(	(rect.right/2) - 120, rect.bottom - n_vert_margin_from_bottom + 27, "me_pankajgarg@hotmail.com");
    }


	dc.SelectObject(pOldFont);
	

	// Do not call CView::OnPaint() for painting messages
}

void CReCClientView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	RECT rect;
	GetClientRect(&rect);
	bool b_same_state = true;
	int n_vert_margin_from_bottom = 54;

	if (	point.x >= (rect.right/2) - 120 && 
			point.x <= (rect.right/2) + 120 && 
			point.y >= rect.bottom - n_vert_margin_from_bottom + 30 &&
			point.y <= rect.bottom - n_vert_margin_from_bottom + 48)
	{
		if (m_b_email_hi == false)
		{
			b_same_state = false;
			m_b_email_hi	= true;
		}
		SetCursor(LoadCursor(GetModuleHandle(NULL), MAKEINTRESOURCE(IDC_HAND_MY)));
	}
	else
	{
		if (m_b_email_hi == true)
		{
			b_same_state = false;
			m_b_email_hi	= false;
		}
	}

	TRACE("\nMOUSEMOVE EMAIL = %d, WEB = %d",m_b_email_hi, m_b_web_hi);
	if (b_same_state == false)
	{
		InvalidateRect(CRect(	(rect.right/2) - 121, rect.bottom - n_vert_margin_from_bottom + 27,
								(rect.right/2) + 121, rect.bottom - n_vert_margin_from_bottom + 49), FALSE);

		TRACE("INVALIDATE CALLED");
	}
	CView::OnMouseMove(nFlags, point);
}

void CReCClientView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CView::OnRButtonDown(nFlags, point);
}

void CReCClientView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if (m_b_email_hi)
		ShellExecute(this->GetSafeHwnd(), NULL, "mailto: me_pankajgarg@hotmail.com", NULL, NULL, SW_SHOW | SW_MAXIMIZE);
	if (m_b_web_hi)
		ShellExecute(this->GetSafeHwnd(), NULL, "www.members.xoom.com/PankajkGarg", NULL, NULL, SW_SHOW | SW_MAXIMIZE);

	CView::OnLButtonDown(nFlags, point);
}

BOOL CReCClientView::OnEraseBkgnd(CDC* pDC) 
{
#if 1
    return CView::OnEraseBkgnd(pDC);
#else
    // This erase the background and make it black
    // This is left over code but not deleted
    // for informational sake
    CBrush backBrush(RGB(0x0, 0x40, 0x0));
    CBrush *pOldBrush = pDC->SelectObject(&backBrush);
    
    CRect rect;
    pDC->GetClipBox(&rect);
    pDC->PatBlt(rect.left, rect.top, rect.Width(), rect.Height(), PATCOPY);

    pDC->SelectObject(pOldBrush);
    
    return TRUE;
#endif
}
