/*
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the Shared Code
 * License (SCL) as published by www.IntellectualHeaven.com;
 * either version 1.0, or (at your option) any later version.
 *
 * You should have received a copy of the SCL 1.0 license,
 * look for file license.txt, along with this software; if not,
 * then please write to xx_pankaj_xx@intellectualheaven.com
 * for an electronic copy of the same.
 */

/* ++
History (in reverse order)

xx_pankaj_xx@intellectualheaven.com   2003-08-18
First version created and checked in CVS
-- */

// RemoteManagerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "winsvc.h"
#include "RemoteManager.h"
#include "RemoteManagerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRemoteManagerDlg dialog

#define SZ_SERVICE_NAME "ReC - Remote Control Service"
int g_n_start;


CRemoteManagerDlg::CRemoteManagerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRemoteManagerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRemoteManagerDlg)
	m_ed_status = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_mouse_on_mail = false;
}

void CRemoteManagerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRemoteManagerDlg)
	DDX_Control(pDX, IDC_STATIC_STATUS, m_static_status);
	DDX_Control(pDX, IDC_BTN_STOP, m_btn_stop);
	DDX_Control(pDX, IDC_BTN_PAUSE, m_btn_pause);
	DDX_Control(pDX, IDC_BTN_START, m_btn_start);
	DDX_Text(pDX, IDC_ED_SERVICE_STATUS, m_ed_status);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRemoteManagerDlg, CDialog)
	//{{AFX_MSG_MAP(CRemoteManagerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_START, OnBtnStart)
	ON_BN_CLICKED(IDC_BTN_PAUSE, OnBtnPause)
	ON_WM_MOUSEMOVE()
	ON_BN_CLICKED(IDC_BTN_STOP, OnBtnStop)
	ON_WM_LBUTTONDOWN()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRemoteManagerDlg message handlers

BOOL CRemoteManagerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	EnableToolTips();
	m_tool_tip.Create(	this,
						TTS_ALWAYSTIP);
	m_tool_tip.AddTool(	&m_btn_start,
						"Start ReC Service");
	m_tool_tip.AddTool(	&m_btn_pause,
						"Pause ReC Service");
	m_tool_tip.AddTool(	&m_btn_stop,
						"Stop ReC Service");
	m_tool_tip.Activate(TRUE);

	// TODO: Add extra initialization here
	m_bit_start.LoadBitmap(IDB_BITMAP_START);
	m_btn_start.SetBitmap(m_bit_start);
	m_bit_stop.LoadBitmap(IDB_BITMAP_STOP);
	m_btn_stop.SetBitmap(m_bit_stop);
	m_bit_pause.LoadBitmap(IDB_BITMAP_PAUSE);
	m_btn_pause.SetBitmap(m_bit_pause);

	m_ed_status = "Service running ....";
	//m_ed_status = "Service stopped ....";
	UpdateData(FALSE);

	bmp_stop.LoadBitmap(IDB_BITMAP_SERVICE_STOPPED);
	bmp_pause.LoadBitmap(IDB_BITMAP_SERVICE_PAUSED);

	bmp_start[0].LoadBitmap(IDB_BITMAP_SERVICE_RUNNING_A);
	bmp_start[1].LoadBitmap(IDB_BITMAP_SERVICE_RUNNING_B);
	bmp_start[2].LoadBitmap(IDB_BITMAP_SERVICE_RUNNING_C);
	bmp_start[3].LoadBitmap(IDB_BITMAP_SERVICE_RUNNING_D);
	bmp_start[4].LoadBitmap(IDB_BITMAP_SERVICE_RUNNING_E);

	UpdateStatus();

	SetTimer(	202,
				2000,
				NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRemoteManagerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this); // device context for painting
		CFont font;
		font.CreateFont(	10,5,0,0,0,
							FALSE,FALSE,FALSE,
							ANSI_CHARSET,
							OUT_DEFAULT_PRECIS,
							CLIP_DEFAULT_PRECIS,
							DEFAULT_QUALITY,
							DEFAULT_PITCH | FF_DONTCARE,
							"Arial");

		dc.SetBkMode(TRANSPARENT);
		CFont *pOldFont = dc.SelectObject(&font);
		dc.TextOut(80,108,"Developed by:");
		dc.TextOut(80,121,"Pankaj Garg");
		
		CFont font1;
		font1.CreateFont(	12,5,0,0,0,
							TRUE,TRUE,FALSE,
							ANSI_CHARSET,
							OUT_DEFAULT_PRECIS,
							CLIP_DEFAULT_PRECIS,
							DEFAULT_QUALITY,
							DEFAULT_PITCH | FF_DONTCARE,
							"Arial");
		dc.SelectObject(pOldFont);
		pOldFont = dc.SelectObject(&font1);

		if (m_mouse_on_mail)
			dc.SetTextColor(RGB(0,0,255));
		else
			dc.SetTextColor(RGB(0,100,100));
		dc.TextOut(72,134,"me_pankajgarg@hotmail.com");

		dc.SelectObject(pOldFont);
		CDialog::OnPaint();
	}
}

HCURSOR CRemoteManagerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRemoteManagerDlg::OnBtnStart() 
{
	//Try to connect to local server and then stop the service
	m_ed_status = "Trying To Start";
	UpdateData(FALSE);

	SC_HANDLE sch_sc_mgr;
	SC_HANDLE sch_service;

	sch_sc_mgr = OpenSCManager(	NULL,
								NULL,
								SC_MANAGER_ALL_ACCESS);

	if (sch_sc_mgr)
	{
		sch_service = OpenService(	sch_sc_mgr,
									SZ_SERVICE_NAME,
									SERVICE_ALL_ACCESS);

		SERVICE_STATUS status;
		if (sch_service)
		{
			QueryServiceStatus(	sch_service,
								&status);

			if (	status.dwCurrentState == SERVICE_STOPPED
					|| status.dwCurrentState == SERVICE_STOP_PENDING
				)
			{
				StartService(	sch_service,
								0,
								NULL);
			}
			else if (	status.dwCurrentState == SERVICE_PAUSED
						|| status.dwCurrentState == SERVICE_PAUSE_PENDING
				)
			{
				ControlService(	sch_service,
								SERVICE_CONTROL_CONTINUE,
								NULL);
			}

			CloseServiceHandle(sch_service);
		}
		CloseServiceHandle(sch_sc_mgr);
	}
}


void CRemoteManagerDlg::OnBtnPause() 
{
	KillTimer(203);
	m_ed_status = "Trying To Pause";
	UpdateData(FALSE);

	SC_HANDLE sch_sc_mgr;
	SC_HANDLE sch_service;

	sch_sc_mgr = OpenSCManager(	NULL,
								NULL,
								SC_MANAGER_ALL_ACCESS);

	if (sch_sc_mgr)
	{
		sch_service = OpenService(	sch_sc_mgr,
									SZ_SERVICE_NAME,
									SERVICE_ALL_ACCESS);

		SERVICE_STATUS status;
		if (sch_service)
		{
			QueryServiceStatus(	sch_service,
								&status);

			ControlService(	sch_service,
							SERVICE_CONTROL_PAUSE,
							NULL);
			CloseServiceHandle(sch_service);
		}
		CloseServiceHandle(sch_sc_mgr);
	}

	/*
	SOCKET rec_sock = socket(	AF_INET,
								SOCK_STREAM,
								0);

	if (rec_sock == INVALID_HANDLE)
	{
		MessageBox(	"TCP/IP Service failure.Most probable cause is that\n your system is running low on resources.",
					"ReC Service Manager");

		return;
	}

	sockaddr_in serv_addr;
	serv_addr.sin_family			= AF_INET;
	serv_addr.sin_port				= htons(5005);
	serv_addr.sin_addr.S_un.S_addr	= inet_addr("localhost");

	if (connect(	rec_sock,
					(const sockaddr*)&serv_addr,
					sizeof(sockaddr)) == SOCKET_ERROR)
	{
		MessageBox(	"Remote service not running..",
					"ReC Service Manager");

		return;
	}

	CString sz_data = "PAUSE";
	if (send(	rec_sock,
				sz_data,
				sz_data.GetLength(),
				0) == SOCKET_ERROR)
	{
		MessageBox(	"TCP/IP send error. Probably service is closed",
					"ReC Service Manager");

		return;
	}

	closesocket(rec_sock);
*/
}


void CRemoteManagerDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	TRACE("\nX = %d, Y = %d", point.x, point.y);
	if (point.x >= 72 && point.x <= 193 && point.y >= 137 && point.y <= 143)
	{
		SetCursor(LoadCursor(GetModuleHandle(NULL), MAKEINTRESOURCE(IDC_HAND_MY)));
		m_mouse_on_mail = true;
	}
	else
	{
		m_mouse_on_mail = false;
	}

	CRect rect(72,136,194,146);
	InvalidateRect(rect,FALSE);
	CDialog::OnMouseMove(nFlags, point);
}


void CRemoteManagerDlg::OnBtnStop() 
{
	KillTimer(203);
	m_ed_status = "Trying To Stop";
	UpdateData(FALSE);

	SC_HANDLE sch_sc_mgr;
	SC_HANDLE sch_service;

	sch_sc_mgr = OpenSCManager(	NULL,
								NULL,
								SC_MANAGER_ALL_ACCESS);

	if (sch_sc_mgr)
	{
		sch_service = OpenService(	sch_sc_mgr,
									SZ_SERVICE_NAME,
									SERVICE_ALL_ACCESS);

		SERVICE_STATUS status;
		if (sch_service)
		{
			QueryServiceStatus(	sch_service,
								&status);

			ControlService(	sch_service,
							SERVICE_CONTROL_STOP,
							NULL);
			CloseServiceHandle(sch_service);
		}
		CloseServiceHandle(sch_sc_mgr);
	}
}


void CRemoteManagerDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if (m_mouse_on_mail)
	{
		ShellExecute(	this->GetSafeHwnd(),
						NULL,
						"mailto: me_pankajgarg@hotmail.com",
						NULL,
						NULL,
						SW_SHOW | SW_MAXIMIZE);
	}
	m_mouse_on_mail = false;
	CRect rect(79,136,182,146);
	InvalidateRect(rect,FALSE);
	CDialog::OnLButtonDown(nFlags, point);
}


BOOL CRemoteManagerDlg::PreTranslateMessage(MSG* pMsg) 
{
	m_tool_tip.RelayEvent(pMsg);
	return CDialog::PreTranslateMessage(pMsg);
}

void CRemoteManagerDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent == 202)
	{
		UpdateStatus();
	}
	else if (nIDEvent == 203)
	{
		m_static_status.SetBitmap(bmp_start[++g_n_start%5]);
	}

	CDialog::OnTimer(nIDEvent);
}

void CRemoteManagerDlg::UpdateStatus()
{
	SC_HANDLE sch_sc_mgr;
	SC_HANDLE sch_service;

	sch_sc_mgr = OpenSCManager(	NULL,
								NULL,
								SC_MANAGER_ALL_ACCESS);

	if (sch_sc_mgr)
	{
		sch_service = OpenService(	sch_sc_mgr,
									SZ_SERVICE_NAME,
									SERVICE_QUERY_STATUS);

		SERVICE_STATUS status;
		if (sch_service)
		{
			QueryServiceStatus(	sch_service,
								&status);

			KillTimer(203);
			if (status.dwCurrentState == SERVICE_STOPPED)
			{
				m_static_status.SetBitmap(bmp_stop);
				m_ed_status = "Service stopped ....";
				UpdateData(FALSE);
			}
			else if (status.dwCurrentState == SERVICE_STOP_PENDING)
			{
				m_ed_status = "Tyring To Stop";
				UpdateData(FALSE);
			}
			else if (status.dwCurrentState == SERVICE_PAUSE_PENDING)
			{
				m_ed_status = "Tyring To Pause";
				UpdateData(FALSE);
			}
			else if (status.dwCurrentState == SERVICE_CONTINUE_PENDING)
			{
				m_ed_status = "Tyring To Start";
				UpdateData(FALSE);
			}
			else if (status.dwCurrentState == SERVICE_PAUSED)
			{
				m_static_status.SetBitmap(bmp_pause);
				m_ed_status = "Service paused ....";
				UpdateData(FALSE);
			}
			else
			{
				SetTimer(203, 100, NULL);
				g_n_start = 0;
				m_static_status.SetBitmap(bmp_start[0]);
				m_ed_status = "Service running ....";
				UpdateData(FALSE);
			}
			CloseServiceHandle(sch_service);
		}
		else
		{
			KillTimer(202);
			MessageBox(	"ReC Service is not installed.\nCannot continue....",
						"Remote Manager : Error",
						MB_OK | MB_ICONSTOP);
			CloseServiceHandle(sch_sc_mgr);
			exit(0);
		}
		CloseServiceHandle(sch_sc_mgr);
	}
	else
	{
		KillTimer(202);
		MessageBox(	"Service Control Manager not responding.\nCannot continue....",
					"Remote Manager : Error",
					MB_OK | MB_ICONSTOP);
		exit(0);
	}

/*
	SOCKET rec_sock = socket(	AF_INET,
								SOCK_STREAM,
								0);

	if (rec_sock == INVALID_HANDLE)
	{
		MessageBox(	"TCP/IP Service failure.Most probable cause is that\n your system is running low on resources.",
					"ReC Service Manager");

		return;
	}

	sockaddr_in serv_addr;
	serv_addr.sin_family			= AF_INET;
	serv_addr.sin_port				= htons(5005);
	serv_addr.sin_addr.S_un.S_addr	= inet_addr("localhost");

	if (connect(	rec_sock,
					(const sockaddr*)&serv_addr,
					sizeof(sockaddr)) == SOCKET_ERROR)
	{
		MessageBox(	"Remote service not running..",
					"ReC Service Manager");

		return;
	}

	CString sz_data = "STATUS";
	if (send(	rec_sock,
				sz_data,
				sz_data.GetLength(),
				0) == SOCKET_ERROR)
	{
		MessageBox(	"TCP/IP send error. Probably service is closed",
					"ReC Service Manager");

		return;
	}
	
	char buf[10];
	int n_byte = 0;
	if ((n_bytes = recv(	rec_sock,
							sz_data,
							sz_data.GetLength(),
							0)) == SOCKET_ERROR)
	{
		MessageBox(	"TCP/IP send error. Probably service is closed",
					"ReC Service Manager");

		return;
	}
	buf[n_byte] = '\0';

	CString temp = buf;
	if (temp == "STOPPED")
	{
*/
}
